_OPACITY = 0.50;
_DENSITY = 20;

(function ($) {
	$.fn.spinload = function (opts) {
		var element = this;
		var spinner = new Spinner({
			"lines": 10,
			"length": 10,
			"width": 5,
			"radius": 20,
			"corners": 1,
			"rotate": 0,
			"direction": 1,
			"color": "#FFFFFF",
			"speed": 1,
			"trail": 50,
			"shadow": false,
			"hwaccel": false,
			"className": "spinner",
			"zIndex": 0,
			"top": "auto",
			"left": "auto"
		}).spin($(element).find(".spinload").get(0));
		
		$(window).bind("load", function (event) {
			setTimeout(function () {
				$(element).find(".spinload").remove();
			}, 1000);
		});
		return (this);
	}
})(jQuery);

(function ($) {
	$.fn.placeholder = function (opts) {
		var element = this;

		$(window).bind("load", function (event) {
			$("[placeholder]").each(function (index) {
				var selection = this;
				
				$(selection).val($(selection).val() == "" ? $(selection).attr("placeholder") : $(selection).val());
			});
			$("[placeholder]").bind("focus", function (event) {
				var selection = this;
				
				$(selection).val($(selection).val() == $(selection).attr("placeholder") ? "" : $(selection).val());
			});
			$("[placeholder]").bind("blur", function (event) {
				var selection = this;
				
				$(selection).val($(selection).val() == "" ? $(selection).attr("placeholder") : $(selection).val());
			});
		});
		return (this);
	}
})(jQuery);

(function ($) {
	$.fn.engine = function (opts) {
		var element = this;
		var density = _DENSITY;
		var fps = 30;
		var ratio = 2;
		var stack = [];
		var cvs = $(element).find(".animation").get(0);
		var ctx = cvs.getContext("2d");
		var generate = function (element) {
			var x = _OPACITY - _OPACITY / (cvs.width / 2) * Math.abs((cvs.width / 2) - element.position.x);
			var y = _OPACITY - _OPACITY / (cvs.height / 2) * Math.abs((cvs.height / 2) - element.position.y);
		
			ctx.beginPath();
			ctx.arc(element.position.x, element.position.y, element.speed.x * element.speed.y % 100, (0 * Math.PI), (2 * Math.PI));
			ctx.globalAlpha = x <= y ? x : y;
			ctx.fillStyle = "rgba(" + element.color.r + ", " + element.color.g + ", " + element.color.b + ", 1)";
			ctx.fill();
			ctx.closePath();
		};
		var fn = function () {
			cvs.style.width = $(element).width();
			cvs.style.height = $(element).height();
			cvs.width = $(element).width() * ratio;
			cvs.height = $(element).height() * ratio;
			ctx.clearRect(0, 0, cvs.width, cvs.height);
			stack.forEach(function (element, index) {
				generate(element);
				element.position.x = ((element.speed.x % 2 ? element.position.x + (element.speed.x / fps) : element.position.x - (element.speed.x / fps)) + cvs.width) % cvs.width;
				element.position.y = ((element.speed.y % 2 ? element.position.y + (element.speed.y / fps) : element.position.y - (element.speed.y / fps)) + cvs.height) % cvs.height;
			});
			setTimeout(function () {fn();}, 1000 / fps);	
		};
		
		while (_DENSITY--) {
			stack.push({
				"position": {
					"x": Math.round(Math.random() * 1000000) % ($(element).width() * ratio),
					"y": Math.round(Math.random() * 1000000) % ($(element).height() * ratio)
				},
				"speed": {
					"x": Math.round(Math.random() * 1000000) % 100,
					"y": Math.round(Math.random() * 1000000) % 100
				},
				"color": {
					"r": Math.round(Math.random() * 1000000) % 64 + 192,
					"g": Math.round(Math.random() * 1000000) % 64 + 192,
					"b": Math.round(Math.random() * 1000000) % 64 + 192
				}
			});
		}
		fn();
		$(window).bind("load scroll resize", function () {
			var opacity = Math.round((1 - 2 / $(element).height() * $(window).scrollTop()) * 100) / 100;
			var margin = Math.round($(element).height() / 2 - $(element).find(".content").height() / 2 - $(window).scrollTop() / 4);
			
			$(element).find(".content").css({"margin": margin + "px auto 0 auto"});
			$(element).find(".content").css({"opacity": opacity >= 0 ? opacity <= 1 ? opacity : 1 : 0});
			$(element).find(".animation").css({"opacity": opacity >= 0 ? opacity <= 1 ? opacity : 1 : 0});
		});
		return (this);
	}
})(jQuery);

$(function () {
	$(document).spinload();
	$(document).placeholder();
});